summaryrefslogtreecommitdiff
path: root/init.d/mtab.in
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
committerRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
commit55eb3794fb4ad563102d5ab30c1d5337a599b2e5 (patch)
tree0d052faeb050c1e18ba56f6f6189bff3ffca28c9 /init.d/mtab.in
parent08aff6ef44ac5dc438d916b53aa61385f6d299f3 (diff)
downloadopenrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.gz
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.bz2
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.xz
Rework our folder structure so that we don't have OS specific dirs, making it easier to share init and conf files per OS.
Diffstat (limited to 'init.d/mtab.in')
-rw-r--r--init.d/mtab.in30
1 files changed, 30 insertions, 0 deletions
diff --git a/init.d/mtab.in b/init.d/mtab.in
new file mode 100644
index 0000000..a0f14b1
--- /dev/null
+++ b/init.d/mtab.in
@@ -0,0 +1,30 @@
+#!@PREFIX@/sbin/runscript
+# Copyright 2007-2008 Roy Marples <roy@marples.name>
+# All rights reserved. Released under the 2-clause BSD license.
+
+description="Update /etc/mtab to match what the kernel knows about"
+
+depend()
+{
+ need root
+ keyword noprefix
+}
+
+start()
+{
+ ebegin "Updating /etc/mtab"
+ if ! echo 2>/dev/null >/etc/mtab; then
+ ewend 1 "/etc/mtab is not updateable"
+ return 0
+ fi
+
+ # With / as tmpfs we cannot umount -at tmpfs in localmount as that
+ # makes / readonly and dismounts all tmpfs even if in use which is
+ # not good. Luckily, umount uses /etc/mtab instead of /proc/mounts
+ # which allows this hack to work.
+ grep -v "^[^ ]* / tmpfs " /proc/mounts > /etc/mtab
+
+ # Remove stale backups
+ rm -f /etc/mtab~ /etc/mtab~~
+ eend 0
+}